diff --git a/src/main/java/net/betterthanadventure/utils/BiomeFinder.java b/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
index c7d7813c0..48d9792e8 100644
--- a/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
+++ b/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
@@ -486,7 +486,7 @@ public class BiomeFinder implements MinecraftAccessor {
 		BiomeProviderOverworld.init();
 		biomeCounts.clear();
 		WorldType worldType = WorldTypes.OVERWORLD_EXTENDED;
-		Dimension dimension = Dimension.overworld;
+		Dimension dimension = Dimension.OVERWORLD;
 		BiomeProvider biomeProvider;
 		World world;
 		if (worldFolder == null){
diff --git a/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java b/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
index d973e777f..ba5a31f2a 100644
--- a/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
+++ b/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
@@ -31,9 +31,9 @@ public class RichPresenceHandlerThread extends Thread {
     private static final Map<Dimension, String> dimensionNamesMap = new HashMap<>();
 
     static {
-        dimensionNamesMap.put(Dimension.overworld, "the Overworld");
-        dimensionNamesMap.put(Dimension.nether, "the Nether");
-        dimensionNamesMap.put(Dimension.paradise, "Paradise");
+        dimensionNamesMap.put(Dimension.OVERWORLD, "the Overworld");
+        dimensionNamesMap.put(Dimension.NETHER, "the Nether");
+        dimensionNamesMap.put(Dimension.PARADISE, "Paradise");
     }
 
     private static final Map<Biome, String> biomeNamesMap = new HashMap<>();
diff --git a/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
index 10fa3233e..980d205bf 100644
--- a/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
+++ b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
@@ -320,7 +320,7 @@ public class LocalPlayer extends Player
 
     @Override
     public void displayGuidebookScreen() {
-        mc.displayScreen(new GuidebookScreen());
+        mc.displayScreen(new GuidebookScreen(mc.currentScreen));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java b/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java
index 2c8de1243..fb58f2013 100644
--- a/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java
+++ b/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java
@@ -190,7 +190,7 @@ public class MultiplayerLocalPlayer extends LocalPlayer
     @Override
 	public void displayGuidebookScreen()
     {
-        mc.displayScreen(new GuidebookScreen());
+        mc.displayScreen(new GuidebookScreen(mc.currentScreen));
         sendQueue.addToSendQueue(new GuidebookPacket(mc.currentScreen instanceof GuidebookScreen));
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/CreateWorldScreen.java b/src/main/java/net/minecraft/client/gui/CreateWorldScreen.java
index c7247209f..b05c47b55 100644
--- a/src/main/java/net/minecraft/client/gui/CreateWorldScreen.java
+++ b/src/main/java/net/minecraft/client/gui/CreateWorldScreen.java
@@ -152,9 +152,9 @@ public class CreateWorldScreen extends Screen {
             String[] keys = new String[WorldTypeGroups.GROUPS.size()];
             String[] descs = new String[WorldTypeGroups.GROUPS.size()];
             for (int i = 0; i < keys.length; i++) {
-                keys[i] = i18n.translateKey(WorldTypeGroups.GROUPS.get(i).get(Dimension.overworld).getLanguageKey() + ".name");
-                descs[i] = i18n.translateKey(WorldTypeGroups.GROUPS.get(i).get(Dimension.overworld).getLanguageKey() + ".desc") + "\n" +
-                    TextFormatting.GRAY + Registries.WORLD_TYPES.getKey(WorldTypeGroups.GROUPS.get(i).get(Dimension.overworld));
+                keys[i] = i18n.translateKey(WorldTypeGroups.GROUPS.get(i).get(Dimension.OVERWORLD).getLanguageKey() + ".name");
+                descs[i] = i18n.translateKey(WorldTypeGroups.GROUPS.get(i).get(Dimension.OVERWORLD).getLanguageKey() + ".desc") + "\n" +
+                    TextFormatting.GRAY + Registries.WORLD_TYPES.getKey(WorldTypeGroups.GROUPS.get(i).get(Dimension.OVERWORLD));
             }
 
             PopupScreen popup = new PopupBuilder(this, 150)
@@ -184,7 +184,7 @@ public class CreateWorldScreen extends Screen {
         I18n i18n = I18n.getInstance();
         gamemodeButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.gamemode", i18n.translateNameKey(selectedGamemode.getLanguageKey()));
         cheatsButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.cheats", i18n.translateKey(cheatsEnabled ? "gui.create_world.button.cheats.on" : "gui.create_world.button.cheats.off"));
-        worldTypeButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.world_type", i18n.translateNameKey(worldTypeGroup.get(Dimension.overworld).getLanguageKey()));
+        worldTypeButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.world_type", i18n.translateNameKey(worldTypeGroup.get(Dimension.OVERWORLD).getLanguageKey()));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/SelectWorldScreen.java b/src/main/java/net/minecraft/client/gui/SelectWorldScreen.java
index bbef928fb..8657b05d9 100644
--- a/src/main/java/net/minecraft/client/gui/SelectWorldScreen.java
+++ b/src/main/java/net/minecraft/client/gui/SelectWorldScreen.java
@@ -330,7 +330,7 @@ public class SelectWorldScreen extends Screen
             {
                 I18n st = I18n.getInstance();
                 LevelData ld = saveFile.getLevelData();
-                DimensionData dd = saveFile.getDimensionData()[0];
+                DimensionData dd = saveFile.getDimensionData().get(0);
                 if (dd == null){
                     s2 += TextFormatting.RED + st.translateKey("gui.select_world.label.dimension_corrupted");
                 } else {
diff --git a/src/main/java/net/minecraft/client/gui/container/AbstractContainerScreen.java b/src/main/java/net/minecraft/client/gui/container/AbstractContainerScreen.java
index 7bc1cc3bc..cd35d8330 100644
--- a/src/main/java/net/minecraft/client/gui/container/AbstractContainerScreen.java
+++ b/src/main/java/net/minecraft/client/gui/container/AbstractContainerScreen.java
@@ -171,8 +171,8 @@ public abstract class AbstractContainerScreen extends Screen
 				Slot slot = inventorySlots.slots.get(slotId);
 				if(slot.hasItem()){
 					String query = "r:"+slot.getItem().getDisplayName()+"!";
-					removed();
-					mc.thePlayer.closeScreen();
+//					removed();
+//					mc.thePlayer.closeScreen();
 					PageManager.searchQuery = SearchQuery.resolve(query);
 					SearchPage.searchField.setText(query);
 					GuidebookScreen.getPageManager().updatePages();
@@ -192,8 +192,8 @@ public abstract class AbstractContainerScreen extends Screen
 				Slot slot = inventorySlots.slots.get(slotId);
 				if(slot.hasItem()) {
 					String query = "u:" + slot.getItem().getDisplayName() + "!";
-					removed();
-					mc.thePlayer.closeScreen();
+//					removed();
+//					mc.thePlayer.closeScreen();
 					PageManager.searchQuery = SearchQuery.resolve(query);
 					SearchPage.searchField.setText(query);
 					GuidebookScreen.getPageManager().updatePages();
@@ -248,6 +248,9 @@ public abstract class AbstractContainerScreen extends Screen
 				mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, InventoryAction.SORT, new int[] {slotId}, mc.thePlayer);
 			}
 		}
+		if (mc.currentScreen == this && mc.gameSettings.keyGuidebook.isKeyboardKey(eventKey)) {
+			mc.thePlayer.displayGuidebookScreen();
+		}
 	}
 
 	@Override
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
index 08e74cfb9..a843288b1 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookPage.java
@@ -40,7 +40,9 @@ public abstract class GuidebookPage
 
     public void onMouseDown(int x, int y, int mouseX, int mouseY, int button) { }
 
-    public void keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) { }
+    public boolean keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
+        return false;
+    }
 
     public void onTick() { }
 
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/GuidebookScreen.java b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookScreen.java
index 0bf98c479..9553d54f6 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/GuidebookScreen.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookScreen.java
@@ -46,9 +46,8 @@ public class GuidebookScreen
     private GuidebookPage lastPage = null;
     private boolean canPlaySound = true;
 
-    public GuidebookScreen() {
-        super();
-
+    public GuidebookScreen(Screen parent) {
+        super(parent);
         getPageManager();
     }
 
@@ -60,6 +59,7 @@ public class GuidebookScreen
         Keyboard.enableRepeatEvents(true);
     }
 
+
     @Override
     public void removed() {
         super.removed();
@@ -254,6 +254,10 @@ public class GuidebookScreen
 
     @Override
     public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
+        if (eventKey == Keyboard.KEY_ESCAPE) {
+            mc.displayScreen(getParentScreen());
+            return;
+        }
         if(eventKey != Keyboard.KEY_BACK) super.keyPressed(eventCharacter, eventKey, mx, my);
 
         int xOffset = 0;
@@ -278,14 +282,19 @@ public class GuidebookScreen
             }
         }
 
+        boolean consumedInput = false;
         if (pageManager.getLeftPage() != null) {
-            pageManager.getLeftPage().keyTyped(eventCharacter, eventKey, left, top, mx, my);
+            consumedInput |= pageManager.getLeftPage().keyTyped(eventCharacter, eventKey, left, top, mx, my);
             updateTabList();
         }
         if (pageManager.getRightPage() != null) {
-            pageManager.getRightPage().keyTyped(eventCharacter, eventKey, left + xSize / 2, top, mx, my);
+            consumedInput |= pageManager.getRightPage().keyTyped(eventCharacter, eventKey, left + xSize / 2, top, mx, my);
             updateTabList();
         }
+
+        if (!consumedInput && mc.gameSettings.keyGuidebook.isKeyboardKey(eventKey)) { // If R pressed and not consumed by page exit guidebook
+            mc.displayScreen(getParentScreen());
+        }
     }
 
     private void handleTabClicks(int mouseX, int mouseY) {
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
index 4610f4a1b..e70e8cb2c 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
@@ -133,7 +133,7 @@ public class CraftingPage
     }
 
     @Override
-    public void keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
+    public boolean keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
         super.keyTyped(c, key, x, y, mouseX, mouseY);
         if(mc.gameSettings.keyShowRecipe.isKeyboardKey(key)){
             GuidebookSlot hoveringSlot= null;
@@ -147,6 +147,7 @@ public class CraftingPage
                     SearchPage.searchField.setText(query);
                     GuidebookScreen.getPageManager().updatePages();
                     GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    return true;
                 }
             }
         } else if (mc.gameSettings.keyShowUsage.isKeyboardKey(key)) {
@@ -161,9 +162,11 @@ public class CraftingPage
                     SearchPage.searchField.setText(query);
                     GuidebookScreen.getPageManager().updatePages();
                     GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    return true;
                 }
             }
         }
+        return false;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
index 68385cd6a..15edb4988 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
@@ -33,8 +33,6 @@ public class MobPage
     private final Class<? extends Entity> mobClass;
     private final MobInfoRegistry.MobInfo mobInfo;
     private final Mob example;
-    private String[] descLines;
-    private String[] unknownDescLines;
     private List<GuidebookSlot> slots;
     private Map<MobInfoRegistry.MobDrop, GuidebookSlot> dropSlotMap;
     private static final Minecraft mc = Minecraft.getMinecraft(GuidebookPage.class);
@@ -113,17 +111,13 @@ public class MobPage
 
         Lighting.disable();
         if(mobInfo != null) {
-            if (descLines == null) {
-                descLines = createDescLines(fr, mobInfo.getDescriptionTranslationKey());
-            }
-            if (unknownDescLines == null) {
-                unknownDescLines = createDescLines(fr, "guidebook.section.mob.undiscovered");
-            }
             I18n i18n = I18n.getInstance();
 
-            String[] lines = descLines;
+            String[] lines;
             if (!discovered) {
-                lines = unknownDescLines;
+                lines = createDescLines(fr, "guidebook.section.mob.undiscovered");
+            } else {
+                lines = createDescLines(fr, mobInfo.getDescriptionTranslationKey());
             }
 
             // Display name
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/search/SearchPage.java b/src/main/java/net/minecraft/client/gui/guidebook/search/SearchPage.java
index b0d9790b7..45f97deee 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/search/SearchPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/search/SearchPage.java
@@ -81,11 +81,13 @@ public class SearchPage extends GuidebookPage {
     }
 
     @Override
-    public void keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
+    public boolean keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
         if(searchField.isFocused) {
             searchField.textboxKeyTyped(c, key);
             PageManager.searchQuery = SearchQuery.resolve(searchField.getText());
             GuidebookScreen.getPageManager().updatePages();
+            return true;
         }
+        return false;
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
index 702373d59..abbd48a68 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
@@ -88,7 +88,7 @@ public class BlastSmeltingPage
     }
 
     @Override
-    public void keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
+    public boolean keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
         super.keyTyped(c, key, x, y, mouseX, mouseY);
         if(mc.gameSettings.keyShowRecipe.isKeyboardKey(key)){
             GuidebookSlot hoveringSlot= null;
@@ -102,6 +102,7 @@ public class BlastSmeltingPage
                     SearchPage.searchField.setText(query);
                     GuidebookScreen.getPageManager().updatePages();
                     GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    return true;
                 }
             }
         } else if (mc.gameSettings.keyShowUsage.isKeyboardKey(key)) {
@@ -116,9 +117,11 @@ public class BlastSmeltingPage
                     SearchPage.searchField.setText(query);
                     GuidebookScreen.getPageManager().updatePages();
                     GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    return true;
                 }
             }
         }
+        return false;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java
index 7df6ee29d..3df44593a 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java
@@ -88,7 +88,7 @@ public class SmeltingPage
     }
 
     @Override
-    public void keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
+    public boolean keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
         super.keyTyped(c, key, x, y, mouseX, mouseY);
         if(mc.gameSettings.keyShowRecipe.isKeyboardKey(key)){
             GuidebookSlot hoveringSlot= null;
@@ -102,6 +102,7 @@ public class SmeltingPage
                     SearchPage.searchField.setText(query);
                     GuidebookScreen.getPageManager().updatePages();
                     GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    return true;
                 }
             }
         } else if (mc.gameSettings.keyShowUsage.isKeyboardKey(key)) {
@@ -116,9 +117,11 @@ public class SmeltingPage
                     SearchPage.searchField.setText(query);
                     GuidebookScreen.getPageManager().updatePages();
                     GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    return true;
                 }
             }
         }
+        return false;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java b/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
index 4757c7745..442371d58 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
@@ -137,7 +137,7 @@ public class TrommelPage
     }
 
     @Override
-    public void keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
+    public boolean keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
         super.keyTyped(c, key, x, y, mouseX, mouseY);
         if(mc.gameSettings.keyShowRecipe.isKeyboardKey(key)){
             GuidebookSlot hoveringSlot= null;
@@ -151,6 +151,7 @@ public class TrommelPage
                     SearchPage.searchField.setText(query);
                     GuidebookScreen.getPageManager().updatePages();
                     GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    return true;
                 }
             }
         } else if (mc.gameSettings.keyShowUsage.isKeyboardKey(key)) {
@@ -165,9 +166,11 @@ public class TrommelPage
                     SearchPage.searchField.setText(query);
                     GuidebookScreen.getPageManager().updatePages();
                     GuidebookScreen.getPageManager().setCurrentPage(GuidebookScreen.getPageManager().getSectionIndex(GuidebookSections.CRAFTING), true);
+                    return true;
                 }
             }
         }
+        return false;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/render/FogManager.java b/src/main/java/net/minecraft/client/render/FogManager.java
index bf0d56965..d081f6611 100644
--- a/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/src/main/java/net/minecraft/client/render/FogManager.java
@@ -96,7 +96,7 @@ public class FogManager {
             {
                 glFogi(NVFogDistance.GL_FOG_DISTANCE_MODE_NV, NVFogDistance.GL_EYE_RADIAL_NV);
             }
-            if(mc.theWorld.dimension == Dimension.nether)
+            if(mc.theWorld.dimension == Dimension.NETHER)
             {
                 glFogf(GL_FOG_START, 0.0F);
             }
diff --git a/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java b/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
index b65761693..f2b1a9ca6 100644
--- a/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
+++ b/src/main/java/net/minecraft/client/render/LoadingScreenRenderer.java
@@ -107,11 +107,11 @@ public class LoadingScreenRenderer
 
     public void updateLoadingBackground(Dimension dimension)
     {
-        if (dimension == Dimension.nether)
+        if (dimension == Dimension.NETHER)
         {
             backgroundPath = "/assets/minecraft/textures/gui/background-loading-nether.png";
         }
-        else if (dimension == Dimension.paradise)
+        else if (dimension == Dimension.PARADISE)
         {
             backgroundPath = "/assets/minecraft/textures/gui/background-loading-paradise.png";
         }
diff --git a/src/main/java/net/minecraft/client/render/PostProcessingManager.java b/src/main/java/net/minecraft/client/render/PostProcessingManager.java
index 85e67a2c7..0cf87c0b1 100644
--- a/src/main/java/net/minecraft/client/render/PostProcessingManager.java
+++ b/src/main/java/net/minecraft/client/render/PostProcessingManager.java
@@ -72,7 +72,7 @@ public class PostProcessingManager
         lastHumidity = humidity;
 
         // Perform base temperature change
-        if (mc.theWorld.dimension == Dimension.overworld)
+        if (mc.theWorld.dimension == Dimension.OVERWORLD)
         {
             lastTemperature = temperature;
             temperature = (temperature * 2) - 1.0; // Ranges from -1.0 to 1.0
@@ -155,7 +155,7 @@ public class PostProcessingManager
         }
 
         // Perform heatwave effects
-        if (mc.theWorld.dimension == Dimension.overworld && (mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER || mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL))
+        if (mc.theWorld.dimension == Dimension.OVERWORLD && (mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER || mc.theWorld.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_FALL))
         {
             if (temperature >= 0.85 && humidity <= 0.15)
             {
diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/src/main/java/net/minecraft/client/render/RenderBlocks.java
index 859cd1d46..ac192d9ad 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -14,7 +14,7 @@ import net.minecraft.core.world.WorldSource;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, RailBlock, Tessellator, IBlockAccess,
-//            BedBlock, ModelBed, RepeaterBlock, BasePistonBlock,
+//            BedBlock, ModelBed, RepeaterBlock, PistonBaseBlock,
 //            BlockPistonExtension, Vec3D, FireBlock, RedstoneWireBlock,
 //            EntityRenderer, FluidBlock, MathHelper, Material,
 //            DoorBlock, World
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index cdaace8af..2a5b68615 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -318,8 +318,12 @@ public class BlockModelDispatcher
 
         addDispatch(new PistonBlockModel<>(Blocks.PISTON_BASE, TextureRegistry.getTexture("minecraft:block/piston_face")).withTextures("minecraft:block/piston_face").withCustomItemBounds(0,0,0,1,1,1));
         addDispatch(new PistonBlockModel<>(Blocks.PISTON_BASE_STICKY,TextureRegistry.getTexture("minecraft:block/piston_face_sticky")).withTextures("minecraft:block/piston_face_sticky").withCustomItemBounds(0,0,0,1,1,1));
-        addDispatch(new PistonHeadBlockModel(Blocks.PISTON_HEAD).withTextures("minecraft:block/piston_face"));
+        addDispatch(new PistonHeadBlockModel(Blocks.PISTON_HEAD, TextureRegistry.getTexture("minecraft:block/piston_side")).withTextures("minecraft:block/piston_face"));
         addDispatch(new EmptyBlockModel(Blocks.PISTON_MOVING));
+        addDispatch(new PistonBlockModel<>(Blocks.PISTON_BASE_STEEL,TextureRegistry.getTexture("minecraft:block/piston_face_steel"), 6/16d)
+            .setPistonTextures("minecraft:block/piston_side_steel", "minecraft:block/piston_top_steel", "minecraft:block/piston_bottom_steel")
+            .withTextures("minecraft:block/piston_face_steel").withCustomItemBounds(0,0,0,1,1,1));
+        addDispatch(new PistonHeadBlockModel(Blocks.PISTON_HEAD_STEEL, TextureRegistry.getTexture("minecraft:block/piston_side_steel"), 6/16d).withTextures("minecraft:block/piston_face_steel"));
 
         addDispatch(new StandardBlockModel<>(Blocks.NOTEBLOCK).withTextures("minecraft:block/noteblock"));
 
@@ -449,6 +453,7 @@ public class BlockModelDispatcher
 
         addDispatch(new FenceThinBlockModel<>(Blocks.FENCE_CHAINLINK,TextureRegistry.getTexture("minecraft:block/fence_chain_center"), null, TextureRegistry.getTexture("minecraft:block/fence_chain_top"), TextureRegistry.getTexture("minecraft:block/fence_chain_column")).withTextures("minecraft:block/fence_chain_center"));
         addDispatch(new FenceThinBlockModel<>(Blocks.FENCE_PAPER_WALL,TextureRegistry.getTexture("minecraft:block/fence_paper_center"), null, null, TextureRegistry.getTexture("minecraft:block/fence_paper_column")).withTextures("minecraft:block/fence_paper_center"));
+        addDispatch(new FenceThinBlockModel<>(Blocks.FENCE_STEEL,TextureRegistry.getTexture("minecraft:block/fence_steel_center"), null, TextureRegistry.getTexture("minecraft:block/fence_steel_top"), TextureRegistry.getTexture("minecraft:block/fence_steel_column")).withTextures("minecraft:block/fence_steel_center"));
 
         addDispatch(new BasketBlockModel<>(Blocks.BASKET).withTextures("minecraft:block/basket_bottom", "minecraft:block/basket_side"));
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/FullRotatableBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/FullRotatableBlockModel.java
index 19ccd91f9..02e606cd1 100644
--- a/src/main/java/net/minecraft/client/render/block/model/FullRotatableBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/FullRotatableBlockModel.java
@@ -4,7 +4,6 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.FullRotatableBlock;
-import net.minecraft.core.block.logic.PistonDirections;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.Nullable;
@@ -71,6 +70,6 @@ public class FullRotatableBlockModel<T extends FullRotatableBlock> extends Stand
         if (side == dir.getSide()) {
             return atlasIndices[Side.TOP.getId()];
         }
-        return side.getId() != PistonDirections.directionMap[dir.getId()] ? atlasIndices[Side.NORTH.getId()] : atlasIndices[Side.BOTTOM.getId()];
+        return side.getDirection() != dir.getOpposite() ? atlasIndices[Side.NORTH.getId()] : atlasIndices[Side.BOTTOM.getId()];
     }
 }
